# coding: utf-8

"""
    FDS API

    API for Flight Dynamics System

    The version of the OpenAPI document: 1.1.0
    Contact: contact@exotrail.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self

class EphemerisRequestDto(BaseModel):
    """
    EphemerisRequestDto
    """ # noqa: E501
    ephemeris_types: List[StrictStr] = Field(description="List of requested ephemeris types", alias="ephemerisTypes")
    id: Optional[StrictStr] = None
    step: Union[Annotated[float, Field(strict=True, gt=0)], Annotated[int, Field(strict=True, gt=0)]] = Field(description="Units: [s]")
    __properties: ClassVar[List[str]] = ["ephemerisTypes", "id", "step"]

    @field_validator('ephemeris_types')
    def ephemeris_types_validate_enum(cls, value):
        """Validates the enum"""
        for i in value:
            if i not in set(['CARTESIAN', 'KEPLERIAN', 'BATTERY', 'QUATERNION', 'THRUST', 'EULER_ANGLES']):
                raise ValueError("each list item must be one of ('CARTESIAN', 'KEPLERIAN', 'BATTERY', 'QUATERNION', 'THRUST', 'EULER_ANGLES')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of EphemerisRequestDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of EphemerisRequestDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "ephemerisTypes": obj.get("ephemerisTypes"),
            "id": obj.get("id"),
            "step": obj.get("step")
        })
        return _obj


